#include "stdafx.h"
#include "ObjFile.h"


//=============================================================================


//! G[\
static void Error(const wchar_t* i_format, ...)
{
  va_list   val;
  wchar_t   message[1024 + 1] = { 0 };
  
  va_start(val, i_format);
  wvsprintf(message, i_format, val);
  va_end(val);
  
  MessageBox(NULL, message, L"G[", MB_ICONEXCLAMATION);
}


//=============================================================================


//! printf() ̑ɌĂяo֐BMessageBox() ŕ\B
static int AlternateOfPrintf(const char* i_format, ...)
{
  int       retval = 0;
  char      message[1024 + 1] = { 0 };
  va_list   val;
  
  va_start(val, i_format);
  retval = wvsprintfA(message, i_format, val);
  va_end(val);
  
  MessageBoxA(NULL, message, "printf()", MB_OK);
  return retval;
}


//=============================================================================


//! ی쑮ύXăvZX̃郉bp֐B
static bool WriteMemory(
  HANDLE        i_process_handle,
  void*         i_address,
  const void*   i_buffer,
  DWORD         i_size
)
{
  bool    retval        = false;
  DWORD   old_protect   = 0;
  DWORD   written_bytes = 0;

  do
  {
    if( VirtualProtectEx(
          i_process_handle,
          i_address,
          i_size,
          PAGE_EXECUTE_READWRITE,
          &old_protect
        ) == FALSE )
    {
      Error(L"̕ی쑮̕ύXɎs܂B\n");
      break;
    }

    if( WriteProcessMemory(
          i_process_handle,
          i_address,
          i_buffer,
          i_size,
          &written_bytes
        ) == FALSE )
    {
      Error(L"݂̏Ɏs܂B\n");
      break;
    }
    
    if( VirtualProtectEx(
          i_process_handle,
          i_address,
          i_size,
          old_protect,
          &old_protect
        ) == FALSE )
    {
      Error(L"̕ی쑮̕ύXɎs܂B\n");
      break;
    }
    
    retval = true;
  }
  while( 0 );
  
  return retval;
}


//=============================================================================


//! printf() tbNB
static bool HookPrintf()
{
  bool  retval = false;

  do
  {
    // obj t@CJ
    ObjFile   obj_file(L"printf.obj");
    if( obj_file.IsOpened() == false )
    {
      Error(L"obj t@C̃I[vɎs܂B\n");
      break;
    }
    
    int printf_index = obj_file.FindSymbol("_printf");
    if( printf_index == -1 )
    {
      Error(L"_printf V{܂łB\n");
      break;
    }
    
    // ^[QbgvÕ[hAhXƃTCYB
    // ͎蔲ŃIvViwb_̒lgB
    BYTE*   load_base = reinterpret_cast<BYTE*>(0x00400000);
    size_t  image_size = 0xF000;
    
    // printf() TB
    BYTE*   printf_p = obj_file.FindSymbolData(
                         printf_index,
                         load_base,
                         image_size
                       );
    if( printf_p == NULL )
    {
      Error(L"printf() ܂łB\n");
      break;
    }
    
    // jmp ߂gݗĂ
    BYTE    jmp_opecode[5]  = { 0xE9, 0 };
    DWORD   jmp_value       = reinterpret_cast<BYTE*>(&AlternateOfPrintf)
                            - (printf_p + sizeof(jmp_opecode))
                            ;
    memcpy(jmp_opecode + 1, &jmp_value, sizeof(DWORD));
    
    // _printf()  jmp ߂ŏB
    retval = WriteMemory(
               GetCurrentProcess(),
               printf_p,
               jmp_opecode,
               sizeof(jmp_opecode)
             );

    retval = true;
  }
  while( 0 );
  
  return retval;
}


//=============================================================================


//! DLL ̃Gg|CgBtbNsB
BOOL WINAPI DllMain(
  HINSTANCE,
  DWORD       i_reason_for_call,
  void*
)
{
  switch( i_reason_for_call )
  {
  case DLL_PROCESS_ATTACH:
    HookPrintf();
    break;
  }
  
  return TRUE;
}

